<?php

class Andy_NofollowManager_BbCode_Formatter_Base extends XFCP_Andy_NofollowManager_BbCode_Formatter_Base
{
    public function renderTagUrl(array $tag, array $rendererStates)
    {
		if (!empty($tag['option']))
		{
			$url = $tag['option'];
			$text = $this->renderSubTree($tag['children'], $rendererStates);
		}
		else
		{
			$url = $this->stringifyTree($tag['children']);
			$text = urldecode($url);
			if (!preg_match('/./u', $text))
			{
				$text = $url;
			}
			$text = XenForo_Helper_String::censorString($text);

			if (!empty($rendererStates['shortenUrl']))
			{
				$length = utf8_strlen($text);
				if ($length > 100)
				{
					$text = utf8_substr_replace($text, '...', 35, $length - 35 - 45);
				}
			}

			$text = htmlspecialchars($text);
		}

		$url = $this->_getValidUrl($url);
		if (!$url)
		{
			return $text;
		}
		else
		{
			list($class, $target, $type) = XenForo_Helper_String::getLinkClassTarget($url);
			if ($type == 'internal')
			{
				$noFollow = '';
			}
			else
			{
				$noFollow = (empty($rendererStates['noFollowDefault']) ? '' : ' rel="nofollow"');
			}

			$href = XenForo_Helper_String::censorString($url);
			$proxyHref = $this->_handleLinkProxyOption($href, $type);

			$proxyAttr = '';
			if ($proxyHref)
			{
				$proxyAttr = ' data-proxy-href="' . htmlspecialchars($proxyHref) . '"';
				$class .= ' ProxyLink';
			}

			$class = $class ? " class=\"$class\"" : '';
			$target = $target ? " target=\"$target\"" : '';
			
			//########################################
			// whitelist start
			//########################################	

			// get options from Admin CP -> Options -> Nofollow Manager -> Whitelist
			$whitelist = XenForo_Application::get('options')->nofollowManagerWhitelist;			

			// remove trailing comma if there is one
			$whitelist = rtrim($whitelist, ',');
			
			// put into array
			$whitelistArray = explode(',', $whitelist);	
			
			// define variable
			$match = 0;
			
			// check url
			foreach ($whitelistArray as $item)
			{
				$pos1 = stripos($url,$item);
				
				if ($pos1 !== false)
				{
					$match = 1;
				}
			}
			
			// if match
			if ($match == 1)
			{
				$noFollow = '';
			}

			//########################################
			// whitelist end
			//########################################			
		
			return $this->_wrapInHtml(
				'<a href="' . htmlspecialchars($href) . '"' . $target . $class . $proxyAttr . $noFollow . '>',
				'</a>',
				$text
			);
		}
	}
}